function RESULT=IBLIB_MAIN_run_all_as_function(param)

% % % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % % %%% This is the only thing one need to change inorder to run the script.
% % % % set parameters
% % % param.fname_data='input/joint_histogram.csv'; % fixed name check if exist
% % % param.fname_pre_determined_clusters='input/pre_determined_clusters.csv';
% % % param.ITER_infocurve=20;
% % % param.ITER_clusters=20;
% % % param.KS=[2 3 4 5 6 7];
% % % param.KS_betaS=[120 150 150 150 150 150];
% % % param.beta_range=[80 1.1000]; 
% % % param.beta_jump=0.5000;
% % % param.name_of_dataset='Dataset'; % not really used with VERBOSE small
% % % 
% % % % VERBOSE=.5;   %only run results (do not plot anything)
% % % VERBOSE=11; %print and draw graphs
% % % 
% % % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

VERBOSE=param.VERBOSE;
RESULT.VERBOSE=VERBOSE;
ITER_clusters=param.ITER_clusters;
ITER_infocurve=param.ITER_infocurve;
KS=param.KS;
RESULT.KS=KS;
KS_betaS=param.KS_betaS;
infocurve_betaS=2.^((log2(max(param.beta_range)):(-abs(param.beta_jump)):log2(min(param.beta_range))));
CNAME=param.name_of_dataset;
fname_pre_determined_clusters=param.fname_pre_determined_clusters;
fname_data=param.fname_data;
session_header_forfiles=[]; % do not save intermidate files!!

TSTART = tic;


% info curve betas...
if isempty(infocurve_betaS)
    mybetaS=2.^((log2(80):(-.1):log2(1.5)));
else
    mybetaS=infocurve_betaS;
end



[msg,RESULT.NAMESX,RESULT.NAMESY,RESULT.yxNUM,RESULT.NAMESZ,RESULT.CATZ_NAMEs,RESULT.CATZs,RESULT.NX,RESULT.NY,RESULT.NZ,RESULT.pyx]=IBLIB_read_data_files(fname_data,fname_pre_determined_clusters);


if RESULT.NZ==0
    display(sprintf('No pre-determined clusters...'));
end

if ~isempty(msg)
    display(sprintf('ERROR:\t%s',msg));
    display(sprintf('Ending session because of error...'));
    return;
else
    display(sprintf('ok reading and processing data!'));
end


if VERBOSE>=10.5
    figure(10);
    imagesc(1:RESULT.NX,1:RESULT.NY,log2(RESULT.pyx+1));
    set(gca,'Xtick',1:RESULT.NX);
    set(gca,'XtickLabel',RESULT.NAMESX);
    set(gca,'Ytick',1:RESULT.NY);
    set(gca,'YtickLabel',RESULT.NAMESY);
    title(CNAME);
end


%normalize histograms
display(sprintf('normalize data...'));
RESULT.pyx=RESULT.pyx/sum(sum(RESULT.pyx));
RESULT.x=sum(RESULT.pyx)';
RESULT.y=sum(RESULT.pyx,2);
RESULT.PYX=RESULT.pyx.*repmat(1./(RESULT.x'+eps),[size(RESULT.pyx,1),1]);
PCX0=ones(RESULT.NX,RESULT.NX);
PCX0=eye(length(RESULT.x));
PTY0=eye(length(RESULT.y));

display(sprintf('computing predetermined clusters...'));
[RESULT.tPCXs,RESULT.tPYCXs,RESULT.tPYCs,RESULT.tPTCs,RESULT.tICXs,RESULT.tIYCs,RESULT.tIYX,RESULT.FUNCZs] =...
    IBLIB_run_predeterminedclusters(RESULT.PYX,RESULT.x,RESULT.y,RESULT.NAMESX,RESULT.CATZs,RESULT.CATZ_NAMEs,session_header_forfiles);



RESULT.INFOPOINTS=[RESULT.tICXs,RESULT.tIYCs];

pertub_probS=[];
temperatureS=[];
what_to_do=[];

display(sprintf('computing info curve...'));
ITER=ITER_infocurve;
[RESULT.PCXs,RESULT.PTYs,RESULT.PTCs,RESULT.PYCs,RESULT.bestLs,RESULT.listLs,RESULT.ICXs,RESULT.ITYs,RESULT.ITCs,RESULT.IYCs,RESULT.IYX]=...
    IBLIB_run_batch_betas(RESULT.x,RESULT.y,PCX0,PTY0,RESULT.PYX,ITER,pertub_probS,temperatureS,what_to_do,VERBOSE,mybetaS,RESULT.NAMESX,session_header_forfiles);
display(sprintf('doing plots (if needed)...'));

display(sprintf('computing optimal clusters...'));
betaS=KS_betaS;
ITER=ITER_clusters;
if ~isempty(KS)
    [RESULT.kPCXs,RESULT.kPTYs,RESULT.kPTCs,RESULT.kPYCs,RESULT.kbestLs,RESULT.klistLs,RESULT.kICXs,RESULT.kITYs,RESULT.kITCs,RESULT.kIYCs,RESULT.kIYX]=IBLIB_run_batch_cluster_sizes(RESULT.x,RESULT.y,RESULT.PYX,ITER,pertub_probS,temperatureS,what_to_do,VERBOSE,KS,betaS,RESULT.NAMESX,session_header_forfiles);
else
    kPCXs={};kPTYs={};kPTCs={};kPYCs={};kbestLs=[];klistLs={};kICXs=[];kITYs=[];kITCs=[];kIYCs=[];kIYX=[];
end

%printing clusters
if VERBOSE>=0.5
    IBLIIB_doplot(RESULT.NZ,RESULT.CATZ_NAMEs,RESULT.KS,RESULT.ICXs,RESULT.IYCs,RESULT.tICXs,RESULT.tIYCs,RESULT.kICXs,RESULT.kIYCs,RESULT.IYX,RESULT.VERBOSE)
end

%plotting evaluation plane
if VERBOSE>1
    IBLIIB_doplot(RESULT.NZ,RESULT.CATZ_NAMEs,RESULT.KS,RESULT.ICXs,RESULT.IYCs,RESULT.tICXs,RESULT.tIYCs,RESULT.kICXs,RESULT.kIYCs,RESULT.IYX,RESULT.VERBOSE);
end

elapsedTime = toc(TSTART);
fprintf('\ntotal computation time: %g sec\n',elapsedTime);
fprintf('\nDONE Successfully!!');
end
