clear all;close all;clc %"To begin at the beginning, It is Spring, moonless night in the small town..." 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% This is the only thing one need to change inorder to run the script.
% set parameters
param.fname_data='input/joint_histogram.csv'; % fixed name check if exist
param.fname_pre_determined_clusters='input/pre_determined_clusters.csv';
pram.ITER_infocurve=20;
param.ITER_clusters=20;
param.KS=[2 3 4 5 6 7];
param.KS_betaS=[120 150 150 150 150 150];
param.beta_range=[80 1.1000]; 
param.beta_jump=0.5000;
param.name_of_dataset='Dataset'; % not really used with VERBOSE small

% VERBOSE=.5;   %only run results (do not plot anything)
VERBOSE=11; %print and draw graphs

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ITER_clusters=param.ITER_clusters;
ITER_infocurve=pram.ITER_infocurve;
KS=param.KS;
KS_betaS=param.KS_betaS;
infocurve_betaS=2.^((log2(max(param.beta_range)):(-abs(param.beta_jump)):log2(min(param.beta_range))));
CNAME=param.name_of_dataset;
fname_pre_determined_clusters=param.fname_pre_determined_clusters;
fname_data=param.fname_data;
session_header_forfiles=[]; % do not save intermidate files!!

TSTART = tic;

% if isempty(KS_betaS)
%     KS_betaS=nan(size(KS));
%     for I=1:length(KS)
%         if KS(I)==2
%             KS_betaS(I)=120;
%         else
%             KS_betaS(I)=150;
%         end
%     end
% end

% info curve betas...
if isempty(infocurve_betaS)
    mybetaS=2.^((log2(80):(-.1):log2(1.5)));
else
    mybetaS=infocurve_betaS;
end


%this line read from the data file. zero probabilites are removed from the
%matrix.
[msg,NAMESX,NAMESY,NUM,NAMESZ,CATZ_NAMEs,CATZs,NX,NY,NZ,pyx]=IBLIB_read_data_files(fname_data,fname_pre_determined_clusters);

if NZ==0
    display(sprintf('No pre-determined clusters...'));
end

if ~isempty(msg)
    display(sprintf('ERROR:\t%s',msg));
    display(sprintf('Ending session because of error...'));
    return;
else
    display(sprintf('ok reading and processing data!'));
end


if VERBOSE>=10.5
    figure(10);
    imagesc(1:NX,1:NY,log2(pyx+1));
    set(gca,'Xtick',1:NX);
    set(gca,'XtickLabel',NAMESX);
    set(gca,'Ytick',1:NY);
    set(gca,'YtickLabel',NAMESY);
    title(CNAME);
end


%normalize histograms
display(sprintf('normalize data...'));
pyx=pyx/sum(sum(pyx));
assert(abs(sum(sum(pyx))-1)<1e-5);
x=sum(pyx)';
y=sum(pyx,2);
PYX=pyx.*repmat(1./(x'+eps),[size(pyx,1),1]);
PCX0=ones(NX,NX);
PCX0=eye(length(x));
PTY0=eye(length(y));

display(sprintf('computing predetermined clusters...'));
[tPCXs,tPYCXs,tPYCs,tPTCs,tICXs,tIYCs,tIYX,FUNCZs] = IBLIB_run_predeterminedclusters(PYX,x,y,NAMESX,CATZs,CATZ_NAMEs,session_header_forfiles);

INFOPOINTS=[tICXs,tIYCs];

pertub_probS=[];
temperatureS=[];
what_to_do=[];

display(sprintf('computing info curve...'));
ITER=ITER_infocurve;
[PCXs,PTYs,PTCs,PYCs,bestLs,listLs,ICXs,ITYs,ITCs,IYCs,IYX]=IBLIB_run_batch_betas(x,y,PCX0,PTY0,PYX,ITER,pertub_probS,temperatureS,what_to_do,VERBOSE,mybetaS,NAMESX,session_header_forfiles);
display(sprintf('doing plots (if needed)...'));

betaS=KS_betaS;
ITER=ITER_clusters;
if ~isempty(KS)
    [kPCXs,kPTYs,kPTCs,kPYCs,kbestLs,klistLs,kICXs,kITYs,kITCs,kIYCs,kIYX]=IBLIB_run_batch_cluster_sizes(x,y,PYX,ITER,pertub_probS,temperatureS,what_to_do,VERBOSE,KS,betaS,NAMESX,session_header_forfiles);
                                                                           
else
    kPCXs={};kPTYs={};kPTCs={};kPYCs={};kbestLs=[];klistLs={};kICXs=[];kITYs=[];kITCs=[];kIYCs=[];kIYX=[];
end

display(sprintf('printing optimal clusters...'));
if VERBOSE>=0.5
    for I=1:length(KS)
        IBLIB_print_clusters(kPCXs{I},x,NAMESX,0.1,1,[]);
    end
end

if VERBOSE>=10
    display(sprintf('doing plots (if needed)...'));
    figure(1);
    IBLIB_doplots_script;
end


elapsedTime = toc(TSTART);
fprintf('\ntotal computation time: %g sec\n',elapsedTime);
fprintf('\nDONE Successfully!!');
display(sprintf('DONE EVERYTHING!!!!'));

