% an internal functions to compute I(C;X), I(T;Y), I(T;C) I(Y;C) and I(Y;X)
% the input is PCX- p(C|X) and PTY p(T|Y) and PYX=p(Y|X)
function [ICX,ITY,ITC,IYC,IYX]=IBLIB_calc_info(x,y,PCX,PTY,PYX)
  c=PCX*x;
  t=PTY*y;
  
  Hy=sum( -y.*log2(y+eps) );
  Hx=sum( -x.*log2(x+eps) );
  Hc=sum( -c.*log2(c+eps) );
  Ht=sum( -t.*log2(t+eps) );
  
  Hcx= - sum((PCX.*log2(PCX+eps))*x);
  Hty= - sum((PTY.*log2(PTY+eps))*y);
  
  PYC=(PYX.*repmat( x' ,[size(PYX,1),1]))*(((PCX).*repmat(  1./(c+eps)  ,[1,size(PCX,2)]))' );
  Hyc= - sum((PYC.*log2(PYC+eps))*c);
  Hyx= - sum((PYX.*log2(PYX+eps))*x);
  
  PTC=PTY*(PYX.*repmat( x' ,[size(PYX,1),1]))*(((PCX).*repmat(  1./(c+eps)  ,[1,size(PCX,2)]))' );
  Htc=  - sum((PTC.*log2(PTC+eps))*c);
    
  ICX= Hc-Hcx;
  ITY= Ht-Hty;
  
  IYC= Hy-Hyc;
  IYX= Hy-Hyx;
  ITC= Ht-Htc;
end