% this function compute information curve for a batch of predetermined
% categories
% PYX is the condional distrebution
% x and y are marginals
% NAMESX are the name of surface tokens
% CATZs is a cell arrray with all the categorical labels of each of the categories
% CATZ_NAMEs is the name of the pre-determined categories
% session_header_forfiles should be empty no need to print intermidiate
% files or the directory name to put intermidiate files (e.g 'output\')
function [tPCXs,tPYCXs,tPYCs,tPTCs,tICXs,tIYCs,tIYX,FUNCZs] = IBLIB_run_predeterminedclusters(PYX,x,y,NAMESX,CATZs,CATZ_NAMEs,session_header_forfiles)
NZ=length(CATZs);
if NZ<=0
    tPCXs={};
    tPYCXs={};
    tPYCs={};
    tPTCs={};
    tICXs={};
    tIYCs=[];
    tIYX=[];
    FUNCZs={};
    return
end
FUNCZs=cell(NZ,1);
tPCXs=cell(NZ,1);
tPYCXs=cell(NZ,1);
tPYCs=cell(NZ,1);
tPTCs=cell(NZ,1);
tICXs=nan(NZ,1);
tIYCs=nan(NZ,1);
NX=length(x);
PTY0=eye(length(y));
for J=1:NZ,
    FUNCZ=unique(CATZs{J});
    FUNCZs{J}=FUNCZ;
    NZM=length(FUNCZ);
    PCTSD=zeros(NZM,NX);
    for I=1:NX,
        for K=1:NZM,
            if strcmp(CATZs{J}{I},FUNCZ{K})
                break;
            end
        end
        assert(strcmp(CATZs{J}{I},FUNCZ{K}));
        PCTSD(K,I)=1;
    end
    
    [tICX,tITY,tITC,tIYC,tIYX]=IBLIB_calc_info(x,y,PCTSD,PTY0,PYX);
    tICXs(J)=tICX;
    tIYCs(J)=tIYC;
    tPCXs{J}=PCTSD;
    tPYCs{J}=PYX*((tPCXs{J}').*repmat(x,[1 size(tPCXs{J},1)]).*repmat((1./((tPCXs{J}*x)+eps))' , [size(tPCXs{J},2) 1]));
    tPYCXs{J}=(tPYCs{J}*tPCXs{J}).*repmat(x',[size(PYX,1) 1]);
    if size(PYX,1)==size(PYX,2)
        tPTCs{J}=tPCXs{J}*PYX*((tPCXs{J}').*repmat(x,[1 size(tPCXs{J},1)]).*repmat((1./((tPCXs{J}*x)+eps))' , [size(tPCXs{J},2) 1]));
    else
        tPTCs{J}=0*PYX;
    end
end


% output pre-determined cluster information fo files
if NZ>0
    INFOPOINTS=[tICXs,tIYCs];
    if ~isempty(session_header_forfiles)
        dlmwrite(sprintf('%spreclusters.infocurve.csv',session_header_forfiles),INFOPOINTS,'delimiter',',','precision',5);
        
        
        fname=sprintf('%spreclusters.names.csv',session_header_forfiles);
        FID=fopen(fname,'w+');
        for I=1:NZ,
            fprintf(FID,'%s\n',CATZ_NAMEs{I});
        end
        fclose(FID);
    end
end

for k=1:NZ,
    if ~isempty(session_header_forfiles)
        if k==1
            dlmwrite(sprintf('%spreclusters.PYX.csv',session_header_forfiles),PYX,'delimiter',',','precision',5);
        end
        msg2=sprintf('%d',k);msgk='00000';msgk((end-length(msg2)+1):end)=msg2(:);NOSCORE=[0];
        dlmwrite(sprintf('%spreclusters.%s.PCX.csv',session_header_forfiles,msgk),tPCXs{k},'delimiter',',','precision',3);
        dlmwrite(sprintf('%spreclusters.%s.PTC.csv',session_header_forfiles,msgk),tPTCs{k},'delimiter',',','precision',3);
        dlmwrite(sprintf('%spreclusters.%s.PCYX.csv',session_header_forfiles,msgk),tPYCXs{k},'delimiter',',','precision',3);
        dlmwrite(sprintf('%spreclusters.%s.scores.csv',session_header_forfiles,msgk),NOSCORE,'delimiter',',','precision',3);
        FIT=fopen(sprintf('%spreclusters.%s.string.csv',session_header_forfiles,msgk),'w+');
        [~,~,msgBB]=IBLIB_print_clusters(tPCXs{k},x,NAMESX,0.1,1,FUNCZs{k});
        fprintf(FIT,'%s\n',msgBB);
        fclose(FIT);
    end
end

end

